CREATE DATABASE IF NOT EXISTS quizzer;
USE quizzer;

# RESET TABLES #
DROP TABLE IF EXISTS QUIZ_CATEGORY;
DROP TABLE IF EXISTS SCORE;
DROP TABLE IF EXISTS QUIZ;

CREATE TABLE QUIZ (
    QUIZ_ID         INT UNSIGNED    AUTO_INCREMENT PRIMARY KEY,
    CREATOR_UUID    VARCHAR(60)     NOT NULL,
    CREATED_TSP     DATETIME        NOT NULL DEFAULT NOW(),
    STARTED_TSP     DATETIME        DEFAULT NULL,
    FINISHED_TSP    DATETIME        DEFAULT NULL,
    PARTICIPANTS    INT UNSIGNED    NOT NULL,
    QUESTIONS       INT UNSIGNED,
    STATE           VARCHAR(20)     NOT NULL
);

CREATE TABLE QUIZ_CATEGORY (
    QUIZ_ID         INT UNSIGNED            AUTO_INCREMENT NOT NULL,
    FOREIGN KEY     (QUIZ_ID) REFERENCES    QUIZ(QUIZ_ID),
    CATEGORY        VARCHAR(30)             NOT NULL,
    PRIMARY KEY     (QUIZ_ID, CATEGORY)
);

CREATE TABLE SCORE(
    SCORE_ID                        INT UNSIGNED    AUTO_INCREMENT PRIMARY KEY,
    QUIZ_ID                         INT UNSIGNED    NOT NULL,
    FOREIGN KEY                     (QUIZ_ID)       REFERENCES QUIZ(QUIZ_ID),
    UUID                            VARCHAR(60)     NOT NULL,
    POINTS                          INT             NOT NULL,
    QUESTIONS_CORRECT               INT             NOT NULL,
    QUESTIONS_INCORRECT             INT             NOT NULL
);